%PETSCOPTIONS class definition
%
%   Usage:
%      options=petscoptions();

classdef petscoptions
    properties (SetAccess=public) 
		 % {{{1
		 options={NoneAnalysisEnum,asmoptions};
		 %used when marshalling
		 analyses=[];
		 strings={};
		 %}}}
	 end
	 methods
		 function disp(o) % {{{1
			 %  display the object
			 disp(sprintf('class ''%s'' object ''%s'' = \n',class(o),inputname(1)));
			 %  display the options
			 for i=1:size(o.options,1),
				 analysis=o.options{i,1};
				 ioptions=o.options{i,2};
				 string=PetscOptions2PetscRc(ioptions);
				 disp(sprintf('   %s -> ''%s''',EnumToString(analysis),string));
			 end
			 disp(sprintf('\n'));
		 end
		 %}}}
		 function o=addoptions(o,analysis,solveroptions) % {{{1
			 %first, find out if analysis has already been supplied
			 found=0;
			 for i=1:size(o.options,1),
				 inanalysis=o.options{i,1};
				 if inanalysis==analysis,
					 found=1;
					 o.options{i,1}=analysis;
					 o.options{i,2}=solveroptions;
					 break;
				 end
			 end
			 if ~found,
				 o.options{end+1,1}=analysis;
				 o.options{end,2}=solveroptions;
			 end
		 end
		 %}}}
		 function o=marshall(o)%{{{1
			 %marshall options into analyses and strings
			 o.analyses=zeros(size(o.options,1),1);
			 o.strings=cell(size(o.options,1),1);
			 for i=1:size(o.options,1),
				 o.analyses(i)=o.options{i,1};
				 o.strings{i}=petscoptiontostring(o.options{i,2});
			 end
		 end
		 %}}}
	end
end
