function petscstring=petscoptiontostring(petscoptions)
%PETSCOPTIONTOSTRING: build a Petsc compatible options string
%
% Usage:     petscstring=PetscOptions2PetscRc(petscoptions);
%

%initialize petscstring: 
petscstring='';

%start writing options
for i=1:length(petscoptions),
	option=petscoptions{i};
	if isempty(option),
		%do nothing
	elseif length(option)==1,
		%this option has only one argument
		petscstring=[petscstring ' -' option{1}];
	elseif length(option)==2,
		%option with value. value can be string or scalar
		if isscalar(option{2}),
			petscstring=[petscstring ' -' option{1} ' ' num2str(option{2})];
		elseif ischar(option{2}),
			petscstring=[petscstring ' -' option{1} ' ' option{2}];
		else
			error(['PetscOptions2PetscRc error: option #' num2str(i) ' is not well formatted']);
		end
	else 
		error(['PetscOptions2PetscRc error: option #' num2str(i) ' is not well formatted']);
	end
end
